#if !defined(RTCTRADEAPI_API_H)
#define RTCTRADEAPI_API_H

#include "RTCUserApiStruct.h"

#ifdef RTCTRADEAPI_EXPORTS
#define RTCTRADEAPI_API __declspec(dllexport)
#else
#define RTCTRADEAPI_API __declspec(dllimport)
#endif

class RTCTradeAPISpi
{
	public:
		///当客户端与TCore建立起通信连接时，该方法被调用。
		virtual void OnFrontConnected(){};
	
		///当客户端与TCore通信连接断开时，该方法被调用。
		virtual void OnFrontDisconnected(){};
		
		///心跳超时警告。当长时间未收到报文时，该方法被调用。
		///@param nTimeLapse 距离上次接收报文的时间
		virtual void OnHeartBeatWarning(int nTimeLapse){};//Unsupported
	
		///客户端认证响应
		virtual void OnRspAuthenticate(ICERspAuthenticateField *pRspAuthenticateField, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///登录请求响应
		virtual void OnRspUserLogin(ICERspUserLoginField *pRspUserLogin, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///登出请求响应
		virtual void OnRspUserLogout(ICEUserLogoutField *pUserLogout, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///用户口令更新请求响应
		virtual void OnRspUserPasswordUpdate(ICEUserPasswordUpdateField *pUserPasswordUpdate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///资金帐户口令更新请求响应
		virtual void OnRspTradingAccountPasswordUpdate(ICETradingAccountPasswordUpdateField *pTradingAccountPasswordUpdate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///报单录入请求响应
		virtual void OnRspOrderInsert(ICEInputOrderField *pInputOrder, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///预埋单录入请求响应
		virtual void OnRspParkedOrderInsert(ICEParkedOrderField *pParkedOrder, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///预埋撤单录入请求响应
		virtual void OnRspParkedOrderAction(ICEParkedOrderActionField *pParkedOrderAction, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///报单操作请求响应
		virtual void OnRspOrderAction(ICEInputOrderActionField *pInputOrderAction, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///查询最大报单数量响应
		virtual void OnRspQueryMaxOrderVolume(ICEQueryMaxOrderVolumeField *pQueryMaxOrderVolume, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///投资者结算结果确认响应
		virtual void OnRspSettlementInfoConfirm(ICESettlementInfoConfirmField *pSettlementInfoConfirm, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///删除预埋单响应
		virtual void OnRspRemoveParkedOrder(ICERemoveParkedOrderField *pRemoveParkedOrder, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///删除预埋撤单响应
		virtual void OnRspRemoveParkedOrderAction(ICERemoveParkedOrderActionField *pRemoveParkedOrderAction, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///执行宣告录入请求响应
		virtual void OnRspExecOrderInsert(ICEInputExecOrderField *pInputExecOrder, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///执行宣告操作请求响应
		virtual void OnRspExecOrderAction(ICEInputExecOrderActionField *pInputExecOrderAction, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///询价录入请求响应
		virtual void OnRspForQuoteInsert(ICEInputForQuoteField *pInputForQuote, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///报价录入请求响应
		virtual void OnRspQuoteInsert(ICEInputQuoteField *pInputQuote, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///报价操作请求响应
		virtual void OnRspQuoteAction(ICEInputQuoteActionField *pInputQuoteAction, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///锁定应答
		virtual void OnRspLockInsert(ICEInputLockField *pInputLock, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///批量报单操作请求响应
		virtual void OnRspBatchOrderAction(ICEInputBatchOrderActionField *pInputBatchOrderAction, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///申请组合录入请求响应
		virtual void OnRspCombActionInsert(ICEInputCombActionField *pInputCombAction, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询报单响应
		virtual void OnRspQryOrder(ICEOrderField *pOrder, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询成交响应
		virtual void OnRspQryTrade(ICETradeField *pTrade, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询投资者持仓响应
		virtual void OnRspQryInvestorPosition(ICEInvestorPositionField *pInvestorPosition, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询资金账户响应
		virtual void OnRspQryTradingAccount(ICETradingAccountField *pTradingAccount, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询投资者响应
		virtual void OnRspQryInvestor(ICEInvestorField *pInvestor, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询交易编码响应
		virtual void OnRspQryTradingCode(ICETradingCodeField *pTradingCode, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询合约保证金率响应
		virtual void OnRspQryInstrumentMarginRate(ICEInstrumentMarginRateField *pInstrumentMarginRate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询合约手续费率响应
		virtual void OnRspQryInstrumentCommissionRate(ICEInstrumentCommissionRateField *pInstrumentCommissionRate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询交易所响应
		virtual void OnRspQryExchange(ICEExchangeField *pExchange, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询产品响应
		virtual void OnRspQryProduct(ICEProductField *pProduct, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询合约响应
		virtual void OnRspQryInstrument(ICEInstrumentField *pInstrument, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询行情响应
		virtual void OnRspQryDepthMarketData(ICEDepthMarketDataField *pDepthMarketData, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询投资者结算结果响应
		virtual void OnRspQrySettlementInfo(ICESettlementInfoField *pSettlementInfo, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询转帐银行响应
		virtual void OnRspQryTransferBank(ICETransferBankField *pTransferBank, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询投资者持仓明细响应
		virtual void OnRspQryInvestorPositionDetail(ICEInvestorPositionDetailField *pInvestorPositionDetail, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询客户通知响应
		virtual void OnRspQryNotice(ICENoticeField *pNotice, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询结算信息确认响应
		virtual void OnRspQrySettlementInfoConfirm(ICESettlementInfoConfirmField *pSettlementInfoConfirm, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询投资者持仓明细响应
		virtual void OnRspQryInvestorPositionCombineDetail(ICEInvestorPositionCombineDetailField *pInvestorPositionCombineDetail, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///查询保证金监管系统经纪公司资金账户密钥响应
		virtual void OnRspQryCFMMCTradingAccountKey(ICECFMMCTradingAccountKeyField *pCFMMCTradingAccountKey, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询仓单折抵信息响应
		virtual void OnRspQryEWarrantOffset(ICEEWarrantOffsetField *pEWarrantOffset, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询投资者品种/跨品种保证金响应
		virtual void OnRspQryInvestorProductGroupMargin(ICEInvestorProductGroupMarginField *pInvestorProductGroupMargin, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询交易所保证金率响应
		virtual void OnRspQryExchangeMarginRate(ICEExchangeMarginRateField *pExchangeMarginRate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询交易所调整保证金率响应
		virtual void OnRspQryExchangeMarginRateAdjust(ICEExchangeMarginRateAdjustField *pExchangeMarginRateAdjust, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询汇率响应
		virtual void OnRspQryExchangeRate(ICEExchangeRateField *pExchangeRate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询二级代理操作员银期权限响应
		virtual void OnRspQrySecAgentACIDMap(ICESecAgentACIDMapField *pSecAgentACIDMap, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询产品报价汇率
		virtual void OnRspQryProductExchRate(ICEProductExchRateField *pProductExchRate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询产品组
		virtual void OnRspQryProductGroup(ICEProductGroupField *pProductGroup, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询做市商合约手续费率响应
		virtual void OnRspQryMMInstrumentCommissionRate(ICEMMInstrumentCommissionRateField *pMMInstrumentCommissionRate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询做市商期权合约手续费响应
		virtual void OnRspQryMMOptionInstrCommRate(ICEMMOptionInstrCommRateField *pMMOptionInstrCommRate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询报单手续费响应
		virtual void OnRspQryInstrumentOrderCommRate(ICEInstrumentOrderCommRateField *pInstrumentOrderCommRate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询期权交易成本响应
		virtual void OnRspQryOptionInstrTradeCost(ICEOptionInstrTradeCostField *pOptionInstrTradeCost, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询期权合约手续费响应
		virtual void OnRspQryOptionInstrCommRate(ICEOptionInstrCommRateField *pOptionInstrCommRate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询执行宣告响应
		virtual void OnRspQryExecOrder(ICEExecOrderField *pExecOrder, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询询价响应
		virtual void OnRspQryForQuote(ICEForQuoteField *pForQuote, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询报价响应
		virtual void OnRspQryQuote(ICEQuoteField *pQuote, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询锁定应答
		virtual void OnRspQryLock(ICELockField *pLock, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询锁定证券仓位应答
		virtual void OnRspQryLockPosition(ICELockPositionField *pLockPosition, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询ETF期权合约手续费响应
		virtual void OnRspQryETFOptionInstrCommRate(ICEETFOptionInstrCommRateField *pETFOptionInstrCommRate, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询投资者分级
		virtual void OnRspQryInvestorLevel(ICEInvestorLevelField *pInvestorLevel, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询E+1日行权冻结响应
		virtual void OnRspQryExecFreeze(ICEExecFreezeField *pExecFreeze, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询组合合约安全系数响应
		virtual void OnRspQryCombInstrumentGuard(ICECombInstrumentGuardField *pCombInstrumentGuard, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询申请组合响应
		virtual void OnRspQryCombAction(ICECombActionField *pCombAction, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询转帐流水响应
		virtual void OnRspQryTransferSerial(ICETransferSerialField *pTransferSerial, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询银期签约关系响应
		virtual void OnRspQryAccountregister(ICEAccountregisterField *pAccountregister, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///错误应答
		virtual void OnRspError(ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///报单通知
		virtual void OnRtnOrder(ICEOrderField *pOrder) {};

		///成交通知
		virtual void OnRtnTrade(ICETradeField *pTrade) {};

		///报单录入错误回报
		virtual void OnErrRtnOrderInsert(ICEInputOrderField *pInputOrder, ICERspInfoField *pRspInfo) {};//Unsupported

		///报单操作错误回报
		virtual void OnErrRtnOrderAction(ICEOrderActionField *pOrderAction, ICERspInfoField *pRspInfo) {};//Unsupported

		///合约交易状态通知
		virtual void OnRtnInstrumentStatus(ICEInstrumentStatusField *pInstrumentStatus) {};//Unsupported

		///交易所公告通知
		virtual void OnRtnBulletin(ICEBulletinField *pBulletin) {};//Unsupported

		///交易通知
		virtual void OnRtnTradingNotice(ICETradingNoticeInfoField *pTradingNoticeInfo) {};

		///提示条件单校验错误
		virtual void OnRtnErrorConditionalOrder(ICEErrorConditionalOrderField *pErrorConditionalOrder) {};//Unsupported

		///执行宣告通知
		virtual void OnRtnExecOrder(ICEExecOrderField *pExecOrder) {};//Unsupported

		///执行宣告录入错误回报
		virtual void OnErrRtnExecOrderInsert(ICEInputExecOrderField *pInputExecOrder, ICERspInfoField *pRspInfo) {};//Unsupported

		///执行宣告操作错误回报
		virtual void OnErrRtnExecOrderAction(ICEExecOrderActionField *pExecOrderAction, ICERspInfoField *pRspInfo) {};//Unsupported

		///询价录入错误回报
		virtual void OnErrRtnForQuoteInsert(ICEInputForQuoteField *pInputForQuote, ICERspInfoField *pRspInfo) {};//Unsupported

		///报价通知
		virtual void OnRtnQuote(ICEQuoteField *pQuote) {};//Unsupported

		///报价录入错误回报
		virtual void OnErrRtnQuoteInsert(ICEInputQuoteField *pInputQuote, ICERspInfoField *pRspInfo) {};//Unsupported

		///报价操作错误回报
		virtual void OnErrRtnQuoteAction(ICEQuoteActionField *pQuoteAction, ICERspInfoField *pRspInfo) {};//Unsupported

		///询价通知
		virtual void OnRtnForQuoteRsp(ICEForQuoteRspField *pForQuoteRsp) {};//Unsupported

		///保证金监控中心用户令牌
		virtual void OnRtnCFMMCTradingAccountToken(ICECFMMCTradingAccountTokenField *pCFMMCTradingAccountToken) {};//Unsupported

		///锁定通知
		virtual void OnRtnLock(ICELockField *pLock) {};

		///锁定错误通知
		virtual void OnErrRtnLockInsert(ICEInputLockField *pInputLock, ICERspInfoField *pRspInfo) {};//Unsupported

		///批量报单操作错误回报
		virtual void OnErrRtnBatchOrderAction(ICEBatchOrderActionField *pBatchOrderAction, ICERspInfoField *pRspInfo) {};//Unsupported

		///申请组合通知
		virtual void OnRtnCombAction(ICECombActionField *pCombAction) {};//Unsupported

		///申请组合录入错误回报
		virtual void OnErrRtnCombActionInsert(ICEInputCombActionField *pInputCombAction, ICERspInfoField *pRspInfo) {};//Unsupported

		///请求查询签约银行响应
		virtual void OnRspQryContractBank(ICEContractBankField *pContractBank, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询预埋单响应
		virtual void OnRspQryParkedOrder(ICEParkedOrderField *pParkedOrder, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询预埋撤单响应
		virtual void OnRspQryParkedOrderAction(ICEParkedOrderActionField *pParkedOrderAction, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询交易通知响应
		virtual void OnRspQryTradingNotice(ICETradingNoticeField *pTradingNotice, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询经纪公司交易参数响应
		virtual void OnRspQryBrokerTradingParams(ICEBrokerTradingParamsField *pBrokerTradingParams, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询经纪公司交易算法响应
		virtual void OnRspQryBrokerTradingAlgos(ICEBrokerTradingAlgosField *pBrokerTradingAlgos, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///请求查询监控中心用户令牌
		virtual void OnRspQueryCFMMCTradingAccountToken(ICEQueryCFMMCTradingAccountTokenField *pQueryCFMMCTradingAccountToken, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///银行发起银行资金转期货通知
		virtual void OnRtnFromBankToFutureByBank(ICERspTransferField *pRspTransfer) {};//Unsupported

		///银行发起期货资金转银行通知
		virtual void OnRtnFromFutureToBankByBank(ICERspTransferField *pRspTransfer) {};//Unsupported

		///银行发起冲正银行转期货通知
		virtual void OnRtnRepealFromBankToFutureByBank(ICERspRepealField *pRspRepeal) {};//Unsupported

		///银行发起冲正期货转银行通知
		virtual void OnRtnRepealFromFutureToBankByBank(ICERspRepealField *pRspRepeal) {};//Unsupported

		///期货发起银行资金转期货通知
		virtual void OnRtnFromBankToFutureByFuture(ICERspTransferField *pRspTransfer) {};//Unsupported

		///期货发起期货资金转银行通知
		virtual void OnRtnFromFutureToBankByFuture(ICERspTransferField *pRspTransfer) {};//Unsupported

		///系统运行时期货端手工发起冲正银行转期货请求，银行处理完毕后报盘发回的通知
		virtual void OnRtnRepealFromBankToFutureByFutureManual(ICERspRepealField *pRspRepeal) {};//Unsupported

		///系统运行时期货端手工发起冲正期货转银行请求，银行处理完毕后报盘发回的通知
		virtual void OnRtnRepealFromFutureToBankByFutureManual(ICERspRepealField *pRspRepeal) {};//Unsupported

		///期货发起查询银行余额通知
		virtual void OnRtnQueryBankBalanceByFuture(ICENotifyQueryAccountField *pNotifyQueryAccount) {};//Unsupported

		///期货发起银行资金转期货错误回报
		virtual void OnErrRtnBankToFutureByFuture(ICEReqTransferField *pReqTransfer, ICERspInfoField *pRspInfo) {};//Unsupported

		///期货发起期货资金转银行错误回报
		virtual void OnErrRtnFutureToBankByFuture(ICEReqTransferField *pReqTransfer, ICERspInfoField *pRspInfo) {};//Unsupported

		///系统运行时期货端手工发起冲正银行转期货错误回报
		virtual void OnErrRtnRepealBankToFutureByFutureManual(ICEReqRepealField *pReqRepeal, ICERspInfoField *pRspInfo) {};//Unsupported

		///系统运行时期货端手工发起冲正期货转银行错误回报
		virtual void OnErrRtnRepealFutureToBankByFutureManual(ICEReqRepealField *pReqRepeal, ICERspInfoField *pRspInfo) {};//Unsupported

		///期货发起查询银行余额错误回报
		virtual void OnErrRtnQueryBankBalanceByFuture(ICEReqQueryAccountField *pReqQueryAccount, ICERspInfoField *pRspInfo) {};//Unsupported

		///期货发起冲正银行转期货请求，银行处理完毕后报盘发回的通知
		virtual void OnRtnRepealFromBankToFutureByFuture(ICERspRepealField *pRspRepeal) {};//Unsupported

		///期货发起冲正期货转银行请求，银行处理完毕后报盘发回的通知
		virtual void OnRtnRepealFromFutureToBankByFuture(ICERspRepealField *pRspRepeal) {};//Unsupported

		///期货发起银行资金转期货应答
		virtual void OnRspFromBankToFutureByFuture(ICEReqTransferField *pReqTransfer, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///期货发起期货资金转银行应答
		virtual void OnRspFromFutureToBankByFuture(ICEReqTransferField *pReqTransfer, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///期货发起查询银行余额应答
		virtual void OnRspQueryBankAccountMoneyByFuture(ICEReqQueryAccountField *pReqQueryAccount, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};//Unsupported

		///银行发起银期开户通知
		virtual void OnRtnOpenAccountByBank(ICEOpenAccountField *pOpenAccount) {};//Unsupported

		///银行发起银期销户通知
		virtual void OnRtnCancelAccountByBank(ICECancelAccountField *pCancelAccount) {};//Unsupported

		///银行发起变更银行账号通知
		virtual void OnRtnChangeAccountByBank(ICEChangeAccountField *pChangeAccount) {};//Unsupported

		///智慧报单录入请求响应
		virtual void OnRspSmartOrderInsert(ICEInputSmartOrderField *pInputSmartOrder, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

		///请求查询投资者持仓分析响应
		virtual void OnRspQryInvestorPositionAnalysis(ICEInvestorPositionAnalysisField *pInvestorPositionAnalysis, ICERspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};
};

class RTCTRADEAPI_API RTCTradeAPI
{
public:
	///创建RTCTradeAPI
	///@return 创建出的RTCTradeAPI
	static RTCTradeAPI *CreateRTCTradeAPI(char *strLogPath = "");

	///初始化
	///@remark 初始化运行环境,只有调用后,接口才开始工作
	virtual bool Init() = 0;//Unsupported

	///删除接口对象本身
	///@remark 不再使用本接口对象时,调用该函数删除接口对象
	virtual void Release() = 0;

	///等待接口线程结束运行
	///@return 线程退出代码
	virtual int Join() = 0;

	///获取当前交易日
	///@retrun 获取到的交易日
	///@remark 只有登录成功后,才能得到正确的交易日
	virtual const char *GetTradingDay() = 0;//Unsupported

	///注册回调接口
	///@param pSpi 派生自回调接口类的实例
	virtual void RegisterSpi(RTCTradeAPISpi *pSpi) = 0;

	///订阅私有流。
	///@param nResumeType 私有流重传方式  
	///        THOST_TERT_RESTART:从本交易日开始重传
	///        THOST_TERT_RESUME:从上次收到的续传
	///        THOST_TERT_QUICK:只传送登录后私有流的内容
	///@remark 该方法要在Init方法前调用。若不调用则不会收到私有流的数据。
	virtual void SubscribePrivateTopic(ICE_TE_RESUME_TYPE nResumeType) = 0;//Unsupported
	
	///订阅公共流。
	///@param nResumeType 公共流重传方式  
	///        THOST_TERT_RESTART:从本交易日开始重传
	///        THOST_TERT_RESUME:从上次收到的续传
	///        THOST_TERT_QUICK:只传送登录后公共流的内容
	///@remark 该方法要在Init方法前调用。若不调用则不会收到公共流的数据。
	virtual void SubscribePublicTopic(ICE_TE_RESUME_TYPE nResumeType) = 0;//Unsupported

	//连接TCore
	virtual long RegisterFront(char *strHostAddress, char *strSystemName, char *strServiceKey, int iConnectType) = 0;

	///客户端认证请求
	virtual int ReqAuthenticate(ICEReqAuthenticateField *pReqAuthenticateField, int nRequestID) = 0;//Unsupported

	///用户登录请求
	virtual int ReqUserLogin(ICEReqUserLoginField *pReqUserLoginField, int nRequestID) = 0;//Unsupported
	
	///登出请求
	virtual int ReqUserLogout(ICEUserLogoutField *pUserLogout, int nRequestID) = 0;//Unsupported

	///用户口令更新请求
	virtual int ReqUserPasswordUpdate(ICEUserPasswordUpdateField *pUserPasswordUpdate, int nRequestID) = 0;

	///资金帐户口令更新请求
	virtual int ReqTradingAccountPasswordUpdate(ICETradingAccountPasswordUpdateField *pTradingAccountPasswordUpdate, int nRequestID) = 0;

	///报单录入请求
	virtual int ReqOrderInsert(ICEInputOrderField *pInputOrder, int nRequestID) = 0;

	///预埋单录入请求
	virtual int ReqParkedOrderInsert(ICEParkedOrderField *pParkedOrder, int nRequestID) = 0;

	///预埋撤单录入请求
	virtual int ReqParkedOrderAction(ICEParkedOrderActionField *pParkedOrderAction, int nRequestID) = 0;//Unsupported

	///报单操作请求
	virtual int ReqOrderAction(ICEInputOrderActionField *pInputOrderAction, int nRequestID) = 0;

	///查询最大报单数量请求
	virtual int ReqQueryMaxOrderVolume(ICEQueryMaxOrderVolumeField *pQueryMaxOrderVolume, int nRequestID) = 0;//Unsupported

	///投资者结算结果确认
	virtual int ReqSettlementInfoConfirm(ICESettlementInfoConfirmField *pSettlementInfoConfirm, int nRequestID) = 0;

	///请求删除预埋单
	virtual int ReqRemoveParkedOrder(ICERemoveParkedOrderField *pRemoveParkedOrder, int nRequestID) = 0;

	///请求删除预埋撤单
	virtual int ReqRemoveParkedOrderAction(ICERemoveParkedOrderActionField *pRemoveParkedOrderAction, int nRequestID) = 0;//Unsupported

	///执行宣告录入请求
	virtual int ReqExecOrderInsert(ICEInputExecOrderField *pInputExecOrder, int nRequestID) = 0;

	///执行宣告操作请求
	virtual int ReqExecOrderAction(ICEInputExecOrderActionField *pInputExecOrderAction, int nRequestID) = 0;

	///询价录入请求
	virtual int ReqForQuoteInsert(ICEInputForQuoteField *pInputForQuote, int nRequestID) = 0;//Unsupported

	///报价录入请求
	virtual int ReqQuoteInsert(ICEInputQuoteField *pInputQuote, int nRequestID) = 0;//Unsupported

	///报价操作请求
	virtual int ReqQuoteAction(ICEInputQuoteActionField *pInputQuoteAction, int nRequestID) = 0;//Unsupported

	///锁定请求
	virtual int ReqLockInsert(ICEInputLockField *pInputLock, int nRequestID) = 0;

	///批量报单操作请求
	virtual int ReqBatchOrderAction(ICEInputBatchOrderActionField *pInputBatchOrderAction, int nRequestID) = 0;//Unsupported

	///申请组合录入请求
	virtual int ReqCombActionInsert(ICEInputCombActionField *pInputCombAction, int nRequestID) = 0;

	///请求查询报单
	virtual int ReqQryOrder(ICEQryOrderField *pQryOrder, int nRequestID) = 0;

	///请求查询成交
	virtual int ReqQryTrade(ICEQryTradeField *pQryTrade, int nRequestID) = 0;

	///请求查询投资者持仓
	virtual int ReqQryInvestorPosition(ICEQryInvestorPositionField *pQryInvestorPosition, int nRequestID) = 0;

	///请求查询资金账户
	virtual int ReqQryTradingAccount(ICEQryTradingAccountField *pQryTradingAccount, int nRequestID) = 0;

	///请求查询投资者
	virtual int ReqQryInvestor(ICEQryInvestorField *pQryInvestor, int nRequestID) = 0;

	///请求查询交易编码
	virtual int ReqQryTradingCode(ICEQryTradingCodeField *pQryTradingCode, int nRequestID) = 0;//Unsupported

	///请求查询合约保证金率
	virtual int ReqQryInstrumentMarginRate(ICEQryInstrumentMarginRateField *pQryInstrumentMarginRate, int nRequestID) = 0;//Unsupported

	///请求查询合约手续费率
	virtual int ReqQryInstrumentCommissionRate(ICEQryInstrumentCommissionRateField *pQryInstrumentCommissionRate, int nRequestID) = 0;//Unsupported

	///请求查询交易所
	virtual int ReqQryExchange(ICEQryExchangeField *pQryExchange, int nRequestID) = 0;//Unsupported

	///请求查询产品
	virtual int ReqQryProduct(ICEQryProductField *pQryProduct, int nRequestID) = 0;//Unsupported

	///请求查询合约
	virtual int ReqQryInstrument(ICEQryInstrumentField *pQryInstrument, int nRequestID) = 0;

	///请求查询行情
	virtual int ReqQryDepthMarketData(ICEQryDepthMarketDataField *pQryDepthMarketData, int nRequestID) = 0;//Unsupported

	///请求查询投资者结算结果
	virtual int ReqQrySettlementInfo(ICEQrySettlementInfoField *pQrySettlementInfo, int nRequestID) = 0;

	///请求查询转帐银行
	virtual int ReqQryTransferBank(ICEQryTransferBankField *pQryTransferBank, int nRequestID) = 0;//Unsupported

	///请求查询投资者持仓明细
	virtual int ReqQryInvestorPositionDetail(ICEQryInvestorPositionDetailField *pQryInvestorPositionDetail, int nRequestID) = 0;

	///请求查询客户通知
	virtual int ReqQryNotice(ICEQryNoticeField *pQryNotice, int nRequestID) = 0;//Unsupported

	///请求查询结算信息确认
	virtual int ReqQrySettlementInfoConfirm(ICEQrySettlementInfoConfirmField *pQrySettlementInfoConfirm, int nRequestID) = 0;//Unsupported

	///请求查询投资者持仓明细
	virtual int ReqQryInvestorPositionCombineDetail(ICEQryInvestorPositionCombineDetailField *pQryInvestorPositionCombineDetail, int nRequestID) = 0;//Unsupported

	///请求查询保证金监管系统经纪公司资金账户密钥
	virtual int ReqQryCFMMCTradingAccountKey(ICEQryCFMMCTradingAccountKeyField *pQryCFMMCTradingAccountKey, int nRequestID) = 0;//Unsupported

	///请求查询仓单折抵信息
	virtual int ReqQryEWarrantOffset(ICEQryEWarrantOffsetField *pQryEWarrantOffset, int nRequestID) = 0;//Unsupported

	///请求查询投资者品种/跨品种保证金
	virtual int ReqQryInvestorProductGroupMargin(ICEQryInvestorProductGroupMarginField *pQryInvestorProductGroupMargin, int nRequestID) = 0;//Unsupported

	///请求查询交易所保证金率
	virtual int ReqQryExchangeMarginRate(ICEQryExchangeMarginRateField *pQryExchangeMarginRate, int nRequestID) = 0;//Unsupported

	///请求查询交易所调整保证金率
	virtual int ReqQryExchangeMarginRateAdjust(ICEQryExchangeMarginRateAdjustField *pQryExchangeMarginRateAdjust, int nRequestID) = 0;//Unsupported

	///请求查询汇率
	virtual int ReqQryExchangeRate(ICEQryExchangeRateField *pQryExchangeRate, int nRequestID) = 0;//Unsupported

	///请求查询二级代理操作员银期权限
	virtual int ReqQrySecAgentACIDMap(ICEQrySecAgentACIDMapField *pQrySecAgentACIDMap, int nRequestID) = 0;//Unsupported

	///请求查询产品报价汇率
	virtual int ReqQryProductExchRate(ICEQryProductExchRateField *pQryProductExchRate, int nRequestID) = 0;//Unsupported

	///请求查询产品组
	virtual int ReqQryProductGroup(ICEQryProductGroupField *pQryProductGroup, int nRequestID) = 0;//Unsupported

	///请求查询做市商合约手续费率
	virtual int ReqQryMMInstrumentCommissionRate(ICEQryMMInstrumentCommissionRateField *pQryMMInstrumentCommissionRate, int nRequestID) = 0;//Unsupported

	///请求查询做市商期权合约手续费
	virtual int ReqQryMMOptionInstrCommRate(ICEQryMMOptionInstrCommRateField *pQryMMOptionInstrCommRate, int nRequestID) = 0;//Unsupported

	///请求查询报单手续费
	virtual int ReqQryInstrumentOrderCommRate(ICEQryInstrumentOrderCommRateField *pQryInstrumentOrderCommRate, int nRequestID) = 0;//Unsupported

	///请求查询期权交易成本
	virtual int ReqQryOptionInstrTradeCost(ICEQryOptionInstrTradeCostField *pQryOptionInstrTradeCost, int nRequestID) = 0;//Unsupported

	///请求查询期权合约手续费
	virtual int ReqQryOptionInstrCommRate(ICEQryOptionInstrCommRateField *pQryOptionInstrCommRate, int nRequestID) = 0;//Unsupported

	///请求查询执行宣告
	virtual int ReqQryExecOrder(ICEQryExecOrderField *pQryExecOrder, int nRequestID) = 0;

	///请求查询询价
	virtual int ReqQryForQuote(ICEQryForQuoteField *pQryForQuote, int nRequestID) = 0;//Unsupported

	///请求查询报价
	virtual int ReqQryQuote(ICEQryQuoteField *pQryQuote, int nRequestID) = 0;//Unsupported

	///请求查询锁定
	virtual int ReqQryLock(ICEQryLockField *pQryLock, int nRequestID) = 0;

	///请求查询锁定证券仓位
	virtual int ReqQryLockPosition(ICEQryLockPositionField *pQryLockPosition, int nRequestID) = 0;

	///请求查询ETF期权合约手续费
	virtual int ReqQryETFOptionInstrCommRate(ICEQryETFOptionInstrCommRateField *pQryETFOptionInstrCommRate, int nRequestID) = 0;//Unsupported

	///请求查询投资者分级
	virtual int ReqQryInvestorLevel(ICEQryInvestorLevelField *pQryInvestorLevel, int nRequestID) = 0;//Unsupported

	///请求查询E+1日行权冻结
	virtual int ReqQryExecFreeze(ICEQryExecFreezeField *pQryExecFreeze, int nRequestID) = 0;//Unsupported

	///请求查询组合合约安全系数
	virtual int ReqQryCombInstrumentGuard(ICEQryCombInstrumentGuardField *pQryCombInstrumentGuard, int nRequestID) = 0;//Unsupported

	///请求查询申请组合
	virtual int ReqQryCombAction(ICEQryCombActionField *pQryCombAction, int nRequestID) = 0;

	///请求查询转帐流水
	virtual int ReqQryTransferSerial(ICEQryTransferSerialField *pQryTransferSerial, int nRequestID) = 0;//Unsupported

	///请求查询银期签约关系
	virtual int ReqQryAccountregister(ICEQryAccountregisterField *pQryAccountregister, int nRequestID) = 0;//Unsupported

	///请求查询签约银行
	virtual int ReqQryContractBank(ICEQryContractBankField *pQryContractBank, int nRequestID) = 0;//Unsupported

	///请求查询预埋单
	virtual int ReqQryParkedOrder(ICEQryParkedOrderField *pQryParkedOrder, int nRequestID) = 0;//Unsupported

	///请求查询预埋撤单
	virtual int ReqQryParkedOrderAction(ICEQryParkedOrderActionField *pQryParkedOrderAction, int nRequestID) = 0;//Unsupported

	///请求查询交易通知
	virtual int ReqQryTradingNotice(ICEQryTradingNoticeField *pQryTradingNotice, int nRequestID) = 0;//Unsupported

	///请求查询经纪公司交易参数
	virtual int ReqQryBrokerTradingParams(ICEQryBrokerTradingParamsField *pQryBrokerTradingParams, int nRequestID) = 0;//Unsupported

	///请求查询经纪公司交易算法
	virtual int ReqQryBrokerTradingAlgos(ICEQryBrokerTradingAlgosField *pQryBrokerTradingAlgos, int nRequestID) = 0;//Unsupported

	///请求查询监控中心用户令牌
	virtual int ReqQueryCFMMCTradingAccountToken(ICEQueryCFMMCTradingAccountTokenField *pQueryCFMMCTradingAccountToken, int nRequestID) = 0;//Unsupported

	///期货发起银行资金转期货请求
	virtual int ReqFromBankToFutureByFuture(ICEReqTransferField *pReqTransfer, int nRequestID) = 0;//Unsupported

	///期货发起期货资金转银行请求
	virtual int ReqFromFutureToBankByFuture(ICEReqTransferField *pReqTransfer, int nRequestID) = 0;//Unsupported

	///期货发起查询银行余额请求
	virtual int ReqQueryBankAccountMoneyByFuture(ICEReqQueryAccountField *pReqQueryAccount, int nRequestID) = 0;//Unsupported

	///智慧报单录入请求
	virtual int ReqSmartOrderInsert(ICEInputSmartOrderField *pInputSmartOrder, int iRequestID) = 0;

	///请求查询投资者持仓分析
	virtual int ReqQryInvestorPositionAnalysis(ICEQryInvestorPositionAnalysisField *pQryInvestorPositionAnalysis, int iRequestID) = 0;
};

#endif